

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Demonstration of SHyFT API implementation of Kalman Filtering on gridded data &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
        <script src="../../_static/jquery.js"></script>
        <script src="../../_static/underscore.js"></script>
        <script src="../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script async="async" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.7/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
        <script type="text/x-mathjax-config">MathJax.Hub.Config({"tex2jax": {"inlineMath": [["$", "$"], ["\\(", "\\)"]], "processEscapes": true, "ignoreClass": "document", "processClass": "math|output_area"}})</script>
        <script src="../../_static/js/bootstrap.min.js"></script>
        <script src="../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="This notebook sets up a Kalman filter and demonstrates how choice of parameters impact the updating" href="kalman_updating.html" />
    <link rel="prev" title="Simulation with the Shyft API" href="../nea-example/advanced_simulation.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../../content/hydrology/getting_started.html">Getting started</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../../content/hydrology/getting_started.html#general-examples">General examples</a></li>
<li class="toctree-l2"><a class="reference internal" href="../../content/hydrology/getting_started.html#configured-simulation">Configured simulation</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../../content/hydrology/getting_started.html#advanced-tools">Advanced tools</a><ul class="current">
<li class="toctree-l3 current"><a class="current reference internal" href="#">Demonstration of SHyFT API implementation of Kalman Filtering on gridded data</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#This-notebook-gives-an-example-of-Met.no-data-post-processing-to-correct-temperature-forecasts-based-on-comparison-to-observations.-The-following-steps-are-described:">This notebook gives an example of Met.no data post-processing to correct temperature forecasts based on comparison to observations. The following steps are described:</a><ul>
<li class="toctree-l5"><a class="reference internal" href="#1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation">1. Loading required python modules and setting path to SHyFT installation</a></li>
<li class="toctree-l5"><a class="reference internal" href="#setup:-1.-Generate-synthetic-data-for-temperature-observation-time-series">setup: 1. Generate synthetic data for temperature observation time-series</a></li>
<li class="toctree-l5"><a class="reference internal" href="#setup-2.-Transform-observation-with-bias-to-grid-using-kriging">setup 2. Transform observation with bias to grid using kriging</a></li>
<li class="toctree-l5"><a class="reference internal" href="#setup-3.-Create-3-forecasts-sets-for-the-1x1-km-grid">setup 3. Create 3 forecasts sets for the 1x1 km grid</a></li>
<li class="toctree-l5"><a class="reference internal" href="#grid-pp:-1.-Transform-forecasts-from-grid-to-observation-points-(IDW)">grid-pp: 1. Transform forecasts from grid to observation points (IDW)</a></li>
<li class="toctree-l5"><a class="reference internal" href="#grid-pp:-2.-Calculate-the-bias-time-series-using-Kalman-filter-on-the-observation-set">grid-pp: 2. Calculate the bias time-series using Kalman filter on the observation set</a></li>
<li class="toctree-l5"><a class="reference internal" href="#grid-pp:-3.-Spread-the-bias-at-observation-points-out-to-the-grid-using-kriging">grid-pp: 3. Spread the bias at observation points out to the grid using kriging</a></li>
<li class="toctree-l5"><a class="reference internal" href="#Presentation&amp;Test:-8.-Finally,-Transform-corrected-forecasts-from-grid-to-observation-points-to-see-if-we-did-reach-the-goal-of-adjusting-the-forecast-(IDW)">Presentation&amp;Test: 8. Finally, Transform corrected forecasts from grid to observation points to see if we did reach the goal of adjusting the forecast (IDW)</a></li>
<li class="toctree-l5"><a class="reference internal" href="#9.-Plot-the-results">9. Plot the results</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="kalman_updating.html">This notebook sets up a Kalman filter and demonstrates how choice of parameters impact the updating</a></li>
<li class="toctree-l3"><a class="reference internal" href="kalman_updating.html#1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation">1. Loading required python modules and setting path to SHyFT installation</a></li>
<li class="toctree-l3"><a class="reference internal" href="kalman_updating.html#2.-Create-Kalman-filter">2. Create Kalman filter</a></li>
<li class="toctree-l3"><a class="reference internal" href="kalman_updating.html#3.-Creates-start-states">3. Creates start states</a></li>
<li class="toctree-l3"><a class="reference internal" href="kalman_updating.html#4.-Update-filter">4. Update filter</a></li>
<li class="toctree-l3"><a class="reference internal" href="kalman_updating.html#5.-Plot-results">5. Plot results</a></li>
<li class="toctree-l3"><a class="reference internal" href="kalman_updating.html#6.-Test-to-see-how-choice-of-parameters-impact-filter">6. Test to see how choice of parameters impact filter</a></li>
<li class="toctree-l3"><a class="reference internal" href="ordinary_kriging_precipitation.html">Grid post-processing of Met.no data using SHyFT API</a></li>
<li class="toctree-l3"><a class="reference internal" href="../penman-monteith/penman-monteith-verification-single-method.html">Penman-Monteith Single Method Verification</a></li>
<li class="toctree-l3"><a class="reference internal" href="../penman-monteith/penman-monteith-sensitivity.html">Penman-Monteith Sensitivity</a></li>
<li class="toctree-l3"><a class="reference internal" href="../radiation/polar_region_radiaiton.html">Checking calculation of Radiation at Polar Region</a></li>
<li class="toctree-l3"><a class="reference internal" href="../radiation/radiation-sensitivity-analysis.html">Sensitivity analysis of radiation routine</a></li>
<li class="toctree-l3"><a class="reference internal" href="../radiation/radiation_camelsdata.html">This notebook demonstarates the radiation algorithm on the camels data:</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../../content/hydrology/getting_started.html">Getting started</a> &raquo;</li>
        
      <li>Demonstration of SHyFT API implementation of Kalman Filtering on gridded data</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/notebooks/grid-pp/gridpp_geopoints.ipynb.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  
<style>
/* CSS for nbsphinx extension */

/* remove conflicting styling from Sphinx themes */
div.nbinput.container div.prompt *,
div.nboutput.container div.prompt *,
div.nbinput.container div.input_area pre,
div.nboutput.container div.output_area pre,
div.nbinput.container div.input_area .highlight,
div.nboutput.container div.output_area .highlight {
    border: none;
    padding: 0;
    margin: 0;
    box-shadow: none;
}

div.nbinput.container > div[class*=highlight],
div.nboutput.container > div[class*=highlight] {
    margin: 0;
}

div.nbinput.container div.prompt *,
div.nboutput.container div.prompt * {
    background: none;
}

div.nboutput.container div.output_area .highlight,
div.nboutput.container div.output_area pre {
    background: unset;
}

div.nboutput.container div.output_area div.highlight {
    color: unset;  /* override Pygments text color */
}

/* avoid gaps between output lines */
div.nboutput.container div[class*=highlight] pre {
    line-height: normal;
}

/* input/output containers */
div.nbinput.container,
div.nboutput.container {
    display: -webkit-flex;
    display: flex;
    align-items: flex-start;
    margin: 0;
    width: 100%;
}
@media (max-width: 540px) {
    div.nbinput.container,
    div.nboutput.container {
        flex-direction: column;
    }
}

/* input container */
div.nbinput.container {
    padding-top: 5px;
}

/* last container */
div.nblast.container {
    padding-bottom: 5px;
}

/* input prompt */
div.nbinput.container div.prompt pre {
    color: #307FC1;
}

/* output prompt */
div.nboutput.container div.prompt pre {
    color: #BF5B3D;
}

/* all prompts */
div.nbinput.container div.prompt,
div.nboutput.container div.prompt {
    width: 4.5ex;
    padding-top: 5px;
    position: relative;
    user-select: none;
}

div.nbinput.container div.prompt > div,
div.nboutput.container div.prompt > div {
    position: absolute;
    right: 0;
    margin-right: 0.3ex;
}

@media (max-width: 540px) {
    div.nbinput.container div.prompt,
    div.nboutput.container div.prompt {
        width: unset;
        text-align: left;
        padding: 0.4em;
    }
    div.nboutput.container div.prompt.empty {
        padding: 0;
    }

    div.nbinput.container div.prompt > div,
    div.nboutput.container div.prompt > div {
        position: unset;
    }
}

/* disable scrollbars on prompts */
div.nbinput.container div.prompt pre,
div.nboutput.container div.prompt pre {
    overflow: hidden;
}

/* input/output area */
div.nbinput.container div.input_area,
div.nboutput.container div.output_area {
    -webkit-flex: 1;
    flex: 1;
    overflow: auto;
}
@media (max-width: 540px) {
    div.nbinput.container div.input_area,
    div.nboutput.container div.output_area {
        width: 100%;
    }
}

/* input area */
div.nbinput.container div.input_area {
    border: 1px solid #e0e0e0;
    border-radius: 2px;
    /*background: #f5f5f5;*/
}

/* override MathJax center alignment in output cells */
div.nboutput.container div[class*=MathJax] {
    text-align: left !important;
}

/* override sphinx.ext.imgmath center alignment in output cells */
div.nboutput.container div.math p {
    text-align: left;
}

/* standard error */
div.nboutput.container div.output_area.stderr {
    background: #fdd;
}

/* ANSI colors */
.ansi-black-fg { color: #3E424D; }
.ansi-black-bg { background-color: #3E424D; }
.ansi-black-intense-fg { color: #282C36; }
.ansi-black-intense-bg { background-color: #282C36; }
.ansi-red-fg { color: #E75C58; }
.ansi-red-bg { background-color: #E75C58; }
.ansi-red-intense-fg { color: #B22B31; }
.ansi-red-intense-bg { background-color: #B22B31; }
.ansi-green-fg { color: #00A250; }
.ansi-green-bg { background-color: #00A250; }
.ansi-green-intense-fg { color: #007427; }
.ansi-green-intense-bg { background-color: #007427; }
.ansi-yellow-fg { color: #DDB62B; }
.ansi-yellow-bg { background-color: #DDB62B; }
.ansi-yellow-intense-fg { color: #B27D12; }
.ansi-yellow-intense-bg { background-color: #B27D12; }
.ansi-blue-fg { color: #208FFB; }
.ansi-blue-bg { background-color: #208FFB; }
.ansi-blue-intense-fg { color: #0065CA; }
.ansi-blue-intense-bg { background-color: #0065CA; }
.ansi-magenta-fg { color: #D160C4; }
.ansi-magenta-bg { background-color: #D160C4; }
.ansi-magenta-intense-fg { color: #A03196; }
.ansi-magenta-intense-bg { background-color: #A03196; }
.ansi-cyan-fg { color: #60C6C8; }
.ansi-cyan-bg { background-color: #60C6C8; }
.ansi-cyan-intense-fg { color: #258F8F; }
.ansi-cyan-intense-bg { background-color: #258F8F; }
.ansi-white-fg { color: #C5C1B4; }
.ansi-white-bg { background-color: #C5C1B4; }
.ansi-white-intense-fg { color: #A1A6B2; }
.ansi-white-intense-bg { background-color: #A1A6B2; }

.ansi-default-inverse-fg { color: #FFFFFF; }
.ansi-default-inverse-bg { background-color: #000000; }

.ansi-bold { font-weight: bold; }
.ansi-underline { text-decoration: underline; }


div.nbinput.container div.input_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight].math,
div.nboutput.container div.output_area.rendered_html,
div.nboutput.container div.output_area > div.output_javascript,
div.nboutput.container div.output_area:not(.rendered_html) > img{
    padding: 5px;
    margin: 0;
}

/* fix copybtn overflow problem in chromium (needed for 'sphinx_copybutton') */
div.nbinput.container div.input_area > div[class^='highlight'],
div.nboutput.container div.output_area > div[class^='highlight']{
    overflow-y: hidden;
}

/* hide copybtn icon on prompts (needed for 'sphinx_copybutton') */
.prompt a.copybtn {
    display: none;
}

/* Some additional styling taken form the Jupyter notebook CSS */
div.rendered_html table {
  border: none;
  border-collapse: collapse;
  border-spacing: 0;
  color: black;
  font-size: 12px;
  table-layout: fixed;
}
div.rendered_html thead {
  border-bottom: 1px solid black;
  vertical-align: bottom;
}
div.rendered_html tr,
div.rendered_html th,
div.rendered_html td {
  text-align: right;
  vertical-align: middle;
  padding: 0.5em 0.5em;
  line-height: normal;
  white-space: normal;
  max-width: none;
  border: none;
}
div.rendered_html th {
  font-weight: bold;
}
div.rendered_html tbody tr:nth-child(odd) {
  background: #f5f5f5;
}
div.rendered_html tbody tr:hover {
  background: rgba(66, 165, 245, 0.2);
}

/* CSS overrides for sphinx_rtd_theme */

/* 24px margin */
.nbinput.nblast.container,
.nboutput.nblast.container {
    margin-bottom: 19px;  /* padding has already 5px */
}

/* ... except between code cells! */
.nblast.container + .nbinput.container {
    margin-top: -19px;
}

.admonition > p:before {
    margin-right: 4px;  /* make room for the exclamation icon */
}

/* Fix math alignment, see https://github.com/rtfd/sphinx_rtd_theme/pull/686 */
.math {
    text-align: unset;
}
</style>
<div class="section" id="Demonstration-of-SHyFT-API-implementation-of-Kalman-Filtering-on-gridded-data">
<h1>Demonstration of SHyFT API implementation of Kalman Filtering on gridded data<a class="headerlink" href="#Demonstration-of-SHyFT-API-implementation-of-Kalman-Filtering-on-gridded-data" title="Permalink to this headline">¶</a></h1>
<div class="section" id="This-notebook-gives-an-example-of-Met.no-data-post-processing-to-correct-temperature-forecasts-based-on-comparison-to-observations.-The-following-steps-are-described:">
<h2>This notebook gives an example of Met.no data post-processing to correct temperature forecasts based on comparison to observations. The following steps are described:<a class="headerlink" href="#This-notebook-gives-an-example-of-Met.no-data-post-processing-to-correct-temperature-forecasts-based-on-comparison-to-observations.-The-following-steps-are-described:" title="Permalink to this headline">¶</a></h2>
<ol class="arabic simple">
<li><p><strong>Loading required python modules and setting path to SHyFT installation</strong></p></li>
</ol>
<p>Setup steps is about creating synthetic data, and backtesting those so that we have a known forecast that gives a certain response at the four observation points</p>
<ol class="arabic simple">
<li><p><strong>Generate synthetic data for temperature observation time-series</strong></p></li>
<li><p><strong>Transform observations from set to grid (Kriging)</strong></p></li>
<li><p><strong>Create 3 forecasts sets for the 1x1 km grid</strong></p></li>
</ol>
<p>grid-pp steps is about orchestrating a grid-pp algorithm given our syntethic data from above</p>
<ol class="arabic simple">
<li><p><strong>Transform forecasts from grid to observation points (IDW)</strong></p></li>
<li><p><strong>Calculate the bias time-series using Kalman filter on the difference of observation and forecast set at the observation points</strong></p></li>
<li><p><strong>Transform bias from set to grid (Kriging) and apply bias to the grid forecast</strong></p></li>
</ol>
<p>Final steps to plot and test the results from the grid-pp steps</p>
<ol class="arabic simple">
<li><p><strong>Transform corrected forecasts grid to the observation points (IDW)</strong></p></li>
<li><p><strong>Plot the results and bias</strong></p></li>
</ol>
<div class="section" id="1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation">
<h3>1. Loading required python modules and setting path to SHyFT installation<a class="headerlink" href="#1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation" title="Permalink to this headline">¶</a></h3>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[1]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># first you should import the third-party python modules which you&#39;ll use later on</span>
<span class="c1"># the first line enables that figures are shown inline, directly in the notebook</span>
<span class="o">%</span><span class="k">pylab</span> inline
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">from</span> <span class="nn">os</span> <span class="kn">import</span> <span class="n">path</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">from</span> <span class="nn">matplotlib</span> <span class="kn">import</span> <span class="n">pyplot</span> <span class="k">as</span> <span class="n">plt</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Populating the interactive namespace from numpy and matplotlib
</pre></div></div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[4]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># once the shyft_path is set correctly, you should be able to import shyft modules</span>
<span class="kn">import</span> <span class="nn">shyft</span>
<span class="kn">from</span> <span class="nn">shyft.api</span> <span class="kn">import</span> <span class="n">shyftdata_dir</span>
<span class="kn">from</span> <span class="nn">shyft</span> <span class="kn">import</span> <span class="n">api</span>

<span class="c1"># if you have problems here, it may be related to having your LD_LIBRARY_PATH</span>
<span class="c1"># pointing to the appropriate libboost_python libraries (.so files)</span>
<span class="kn">from</span> <span class="nn">shyft.repository.default_state_repository</span> <span class="kn">import</span> <span class="n">DefaultStateRepository</span>
<span class="kn">from</span> <span class="nn">shyft.orchestration.configuration</span> <span class="kn">import</span> <span class="n">yaml_configs</span>
<span class="kn">from</span> <span class="nn">shyft.orchestration.simulators.config_simulator</span> <span class="kn">import</span> <span class="n">ConfigSimulator</span>
<span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="n">Calendar</span>
<span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="n">deltahours</span>
<span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="n">TimeAxis</span>
<span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="n">TimeSeries</span>
<span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="n">time_shift</span>
<span class="kn">from</span> <span class="nn">shyft.api</span> <span class="kn">import</span> <span class="n">TemperatureSource</span>
<span class="kn">from</span> <span class="nn">shyft.api</span> <span class="kn">import</span> <span class="n">TemperatureSourceVector</span>
<span class="kn">from</span> <span class="nn">shyft.api</span> <span class="kn">import</span> <span class="n">GeoPoint</span>
<span class="kn">from</span> <span class="nn">shyft.api</span> <span class="kn">import</span> <span class="n">GeoPointVector</span>
<span class="kn">from</span> <span class="nn">shyft.api</span> <span class="kn">import</span> <span class="n">bayesian_kriging_temperature</span>
<span class="kn">from</span> <span class="nn">shyft.api</span> <span class="kn">import</span> <span class="n">BTKParameter</span>
<span class="kn">from</span> <span class="nn">shyft.api</span> <span class="kn">import</span> <span class="n">idw_temperature</span>
<span class="kn">from</span> <span class="nn">shyft.api</span> <span class="kn">import</span> <span class="n">IDWTemperatureParameter</span>
<span class="kn">from</span> <span class="nn">shyft.api</span> <span class="kn">import</span> <span class="n">KalmanFilter</span>
<span class="kn">from</span> <span class="nn">shyft.api</span> <span class="kn">import</span> <span class="n">KalmanState</span>
<span class="kn">from</span> <span class="nn">shyft.api</span> <span class="kn">import</span> <span class="n">KalmanBiasPredictor</span>
<span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="n">create_periodic_pattern_ts</span>
<span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="n">POINT_AVERAGE_VALUE</span> <span class="k">as</span> <span class="n">stair_case</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[5]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># now you can access the api of shyft with tab completion and help, try this:</span>

<span class="c1">#help(api.GeoPoint) # remove the hashtag and run the cell to print the documentation of the api.GeoPoint class</span>
<span class="c1">#api. # remove the hashtag, set the pointer behind the dot and use</span>
      <span class="c1"># tab completion to see the available attributes of the shyft api</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="setup:-1.-Generate-synthetic-data-for-temperature-observation-time-series">
<h3>setup: 1. Generate synthetic data for temperature observation time-series<a class="headerlink" href="#setup:-1.-Generate-synthetic-data-for-temperature-observation-time-series" title="Permalink to this headline">¶</a></h3>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[6]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Create time-axis for our syntethic sample</span>
<span class="n">utc</span> <span class="o">=</span> <span class="n">Calendar</span><span class="p">()</span> <span class="c1"># provide conversion and math for utc time-zone</span>
<span class="n">t0</span> <span class="o">=</span> <span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2016</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>
<span class="n">dt</span> <span class="o">=</span> <span class="n">deltahours</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>
<span class="n">n</span> <span class="o">=</span> <span class="mi">24</span><span class="o">*</span><span class="mi">3</span> <span class="c1"># 3 days length</span>
<span class="c1">#ta = TimeAxisFixedDeltaT(t0, dt, n)</span>
<span class="n">ta</span> <span class="o">=</span> <span class="n">TimeAxis</span><span class="p">(</span><span class="n">t0</span><span class="p">,</span> <span class="n">dt</span><span class="p">,</span> <span class="n">n</span><span class="p">)</span> <span class="c1"># same as ta, but needed for now(we work on aligning them)</span>

<span class="c1"># 1. Create the terrain based geo-points for the 1x1km grid and the observations</span>

<span class="c1"># a. Create the grid, based on a syntethic terrain model</span>
<span class="c1"># specification of 1 x 1 km</span>
<span class="n">grid_1x1</span> <span class="o">=</span> <span class="n">GeoPointVector</span><span class="p">()</span>
<span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">10</span><span class="p">):</span>
    <span class="k">for</span> <span class="n">y</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">10</span><span class="p">):</span>
        <span class="n">grid_1x1</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">GeoPoint</span><span class="p">(</span><span class="n">x</span><span class="o">*</span><span class="mi">1000</span><span class="p">,</span> <span class="n">y</span><span class="o">*</span><span class="mi">1000</span><span class="p">,</span> <span class="p">(</span><span class="n">x</span><span class="o">+</span><span class="n">y</span><span class="p">)</span><span class="o">*</span><span class="mi">50</span><span class="p">))</span> <span class="c1"># z from 0 to 1000 m</span>

<span class="c1"># b. Create the observation points, for metered temperature</span>
<span class="c1"># reasonable withing that grid_1x1, and with elevation z</span>
<span class="c1"># that corresponds approximately to the position</span>
<span class="n">obs_points</span> <span class="o">=</span> <span class="n">GeoPointVector</span><span class="p">()</span>
<span class="n">obs_points</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">GeoPoint</span><span class="p">(</span> <span class="mi">100</span><span class="p">,</span> <span class="mi">100</span><span class="p">,</span> <span class="mi">10</span><span class="p">))</span>  <span class="c1"># observation point at the lowest part</span>
<span class="n">obs_points</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">GeoPoint</span><span class="p">(</span><span class="mi">5100</span><span class="p">,</span> <span class="mi">100</span><span class="p">,</span> <span class="mi">270</span> <span class="p">))</span> <span class="c1"># halfway out in x-direction @ 270 masl</span>
<span class="n">obs_points</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">GeoPoint</span><span class="p">(</span> <span class="mi">100</span><span class="p">,</span> <span class="mi">5100</span><span class="p">,</span> <span class="mi">250</span><span class="p">))</span> <span class="c1"># halfway out in y-direction @ 250 masl</span>
<span class="n">obs_points</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">GeoPoint</span><span class="p">(</span><span class="mi">10100</span><span class="p">,</span><span class="mi">10100</span><span class="p">,</span> <span class="mi">1080</span> <span class="p">))</span> <span class="c1"># x-y at max, so @1080 masl</span>

<span class="c1"># 2. Create time-series having a constant temperature of 15 degC</span>
<span class="c1">#    and add them to the syntetic observation set</span>
<span class="c1">#    make sure there is some reality, like temperature gradient etc.</span>
<span class="n">ts</span> <span class="o">=</span> <span class="n">TimeSeries</span><span class="p">(</span><span class="n">ta</span><span class="p">,</span> <span class="n">fill_value</span><span class="o">=</span><span class="mf">20.0</span><span class="p">,</span><span class="n">point_fx</span><span class="o">=</span><span class="n">stair_case</span><span class="p">)</span>  <span class="c1"># 20 degC at z_t= 0 meter above sea-level</span>
<span class="c1"># assume set temp.gradient to -0.6 degC/100m, and estimate the other values accordingly</span>
<span class="n">tgrad</span> <span class="o">=</span> <span class="o">-</span><span class="mf">0.6</span><span class="o">/</span><span class="mf">100.0</span>  <span class="c1"># in our case in units of degC/m</span>
<span class="n">z_t</span> <span class="o">=</span> <span class="mi">0</span> <span class="c1"># meter above sea-level</span>

<span class="c1"># Create a TemperatureSourceVector to hold the set of observation time-series</span>
<span class="n">constant_bias</span><span class="o">=</span><span class="p">[</span><span class="o">-</span><span class="mf">1.0</span><span class="p">,</span><span class="o">-</span><span class="mf">0.6</span><span class="p">,</span><span class="mf">0.7</span><span class="p">,</span><span class="o">+</span><span class="mf">1.0</span><span class="p">]</span>
<span class="n">obs_set</span> <span class="o">=</span> <span class="n">TemperatureSourceVector</span><span class="p">()</span>
<span class="n">obs_set_w_bias</span> <span class="o">=</span> <span class="n">TemperatureSourceVector</span><span class="p">()</span>
<span class="k">for</span> <span class="n">geo_point</span><span class="p">,</span><span class="n">bias</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">obs_points</span><span class="p">,</span><span class="n">constant_bias</span><span class="p">):</span>
    <span class="n">temp_at_site</span> <span class="o">=</span>  <span class="n">ts</span> <span class="o">+</span> <span class="n">tgrad</span><span class="o">*</span><span class="p">(</span><span class="n">geo_point</span><span class="o">.</span><span class="n">z</span><span class="o">-</span><span class="n">z_t</span><span class="p">)</span>
    <span class="n">obs_set</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">TemperatureSource</span><span class="p">(</span><span class="n">geo_point</span><span class="p">,</span><span class="n">temp_at_site</span><span class="p">))</span>
    <span class="n">obs_set_w_bias</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">TemperatureSource</span><span class="p">(</span><span class="n">geo_point</span><span class="p">,</span><span class="n">temp_at_site</span> <span class="o">+</span> <span class="n">bias</span><span class="p">))</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="setup-2.-Transform-observation-with-bias-to-grid-using-kriging">
<h3>setup 2. Transform observation with bias to grid using kriging<a class="headerlink" href="#setup-2.-Transform-observation-with-bias-to-grid-using-kriging" title="Permalink to this headline">¶</a></h3>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[7]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Generate the observation grid by kriging the observations out to 1x1km grid</span>
<span class="c1"># first create idw and kriging parameters that we will utilize in the next steps</span>
<span class="c1"># kriging parameters</span>
<span class="n">btk_params</span> <span class="o">=</span> <span class="n">BTKParameter</span><span class="p">()</span>  <span class="c1"># we could tune parameters here if needed</span>
<span class="c1"># idw parameters,somewhat adapted to the fact that we</span>
<span class="c1">#  know we interpolate from a grid, with a lot of neigbours around</span>
<span class="n">idw_params</span> <span class="o">=</span> <span class="n">IDWTemperatureParameter</span><span class="p">()</span> <span class="c1"># here we could tune the paramete if needed</span>
<span class="n">idw_params</span><span class="o">.</span><span class="n">max_distance</span> <span class="o">=</span> <span class="mi">20</span><span class="o">*</span><span class="mf">1000.0</span> <span class="c1"># max at 10 km because we search for max-gradients</span>
<span class="n">idw_params</span><span class="o">.</span><span class="n">max_members</span> <span class="o">=</span> <span class="mi">20</span> <span class="c1"># for grid, this include all possible close neighbors</span>
<span class="n">idw_params</span><span class="o">.</span><span class="n">gradient_by_equation</span> <span class="o">=</span> <span class="kc">True</span> <span class="c1"># resolve horisontal component out</span>
<span class="c1"># now use kriging for our &#39;syntethic&#39; observations with bias</span>
<span class="n">obs_grid</span> <span class="o">=</span> <span class="n">bayesian_kriging_temperature</span><span class="p">(</span><span class="n">obs_set_w_bias</span><span class="p">,</span><span class="n">grid_1x1</span><span class="p">,</span><span class="n">ta</span><span class="o">.</span><span class="n">fixed_dt</span><span class="p">,</span><span class="n">btk_params</span><span class="p">)</span>


<span class="c1"># if we idw/btk back to the sites, we should have something that equals the with_bias:</span>
<span class="c1"># we should get close to zero differences in this to-grid-and-back operation</span>
<span class="n">back_test</span> <span class="o">=</span> <span class="n">idw_temperature</span><span class="p">(</span><span class="n">obs_grid</span><span class="p">,</span> <span class="n">obs_points</span><span class="p">,</span> <span class="n">ta</span><span class="o">.</span><span class="n">fixed_dt</span><span class="p">,</span> <span class="n">idw_params</span><span class="p">)</span>  <span class="c1"># note the ta.fixed_dt here!</span>
<span class="k">for</span> <span class="n">bt</span><span class="p">,</span><span class="n">wb</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">back_test</span><span class="p">,</span><span class="n">obs_set_w_bias</span><span class="p">):</span>
    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;IDW Diff </span><span class="si">{}</span><span class="s2"> : </span><span class="si">{}</span><span class="s2"> &quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">bt</span><span class="o">.</span><span class="n">mid_point</span><span class="p">(),</span><span class="nb">abs</span><span class="p">((</span><span class="n">bt</span><span class="o">.</span><span class="n">ts</span><span class="o">-</span><span class="n">wb</span><span class="o">.</span><span class="n">ts</span><span class="p">)</span><span class="o">.</span><span class="n">values</span><span class="o">.</span><span class="n">to_numpy</span><span class="p">())</span><span class="o">.</span><span class="n">max</span><span class="p">()))</span>

<span class="c1">#back_test = bayesian_kriging_temperature(obs_grid, obs_points, ta, btk_params)</span>
<span class="c1">#for bt,wb in zip(back_test,obs_set_w_bias):</span>
<span class="c1">#    print(&quot;BTK Diff {} : {} &quot;.format(bt.mid_point(),abs((bt.ts-wb.ts).values.to_numpy()).max()))</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
IDW Diff GeoPoint(100.0,100.0,10.0) : 0.02689547413054072
IDW Diff GeoPoint(5100.0,100.0,270.0) : 0.03278720737047891
IDW Diff GeoPoint(100.0,5100.0,250.0) : 0.05652912605363625
IDW Diff GeoPoint(10100.0,10100.0,1080.0) : 0.004978394986949297
</pre></div></div>
</div>
</div>
<div class="section" id="setup-3.-Create-3-forecasts-sets-for-the-1x1-km-grid">
<h3>setup 3. Create 3 forecasts sets for the 1x1 km grid<a class="headerlink" href="#setup-3.-Create-3-forecasts-sets-for-the-1x1-km-grid" title="Permalink to this headline">¶</a></h3>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[8]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Create a forecast grid by copying the obs_grid time-series</span>
<span class="c1"># since we know that idw of them to obs_points will give approx.</span>
<span class="c1">#  the obs_set_w_bias time-series</span>
<span class="c1">#  for the simplicity, we assume the same forecast for all 3 days</span>

<span class="n">fc_grid</span> <span class="o">=</span> <span class="n">TemperatureSourceVector</span><span class="p">()</span>
<span class="n">fc_grid_1_day_back</span> <span class="o">=</span> <span class="n">TemperatureSourceVector</span><span class="p">()</span> <span class="c1"># this is previous day</span>
<span class="n">fc_grid_2_day_back</span> <span class="o">=</span> <span class="n">TemperatureSourceVector</span><span class="p">()</span>  <span class="c1"># this is fc two days ago</span>
<span class="n">one_day_back_dt</span> <span class="o">=</span> <span class="n">deltahours</span><span class="p">(</span><span class="o">-</span><span class="mi">24</span><span class="p">)</span>
<span class="n">two_days_back_dt</span> <span class="o">=</span> <span class="n">deltahours</span><span class="p">(</span><span class="o">-</span><span class="mi">24</span><span class="o">*</span><span class="mi">2</span><span class="p">)</span>
<span class="n">noise_bias</span> <span class="o">=</span> <span class="p">[</span><span class="mf">0.0</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">obs_grid</span><span class="p">))]</span> <span class="c1"># we could generate white noise ts into these to test kalman</span>
<span class="k">for</span> <span class="n">fc</span><span class="p">,</span><span class="n">bias</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">obs_grid</span><span class="p">,</span><span class="n">noise_bias</span><span class="p">):</span>
    <span class="n">fc_grid</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">TemperatureSource</span><span class="p">(</span><span class="n">fc</span><span class="o">.</span><span class="n">mid_point</span><span class="p">(),</span><span class="n">fc</span><span class="o">.</span><span class="n">ts</span> <span class="o">+</span> <span class="n">bias</span> <span class="p">))</span>
    <span class="n">fc_grid_1_day_back</span><span class="o">.</span><span class="n">append</span><span class="p">(</span>
        <span class="n">TemperatureSource</span><span class="p">(</span>
                <span class="n">fc</span><span class="o">.</span><span class="n">mid_point</span><span class="p">(),</span>
                <span class="n">time_shift</span><span class="p">(</span><span class="n">fc</span><span class="o">.</span><span class="n">ts</span> <span class="o">+</span> <span class="n">bias</span><span class="p">,</span> <span class="n">one_day_back_dt</span><span class="p">)</span> <span class="c1">#time-shift the signal back</span>
            <span class="p">)</span>
        <span class="p">)</span>
    <span class="n">fc_grid_2_day_back</span><span class="o">.</span><span class="n">append</span><span class="p">(</span>
        <span class="n">TemperatureSource</span><span class="p">(</span>
                <span class="n">fc</span><span class="o">.</span><span class="n">mid_point</span><span class="p">(),</span>
                <span class="n">time_shift</span><span class="p">(</span><span class="n">fc</span><span class="o">.</span><span class="n">ts</span> <span class="o">+</span> <span class="n">bias</span><span class="p">,</span> <span class="n">two_days_back_dt</span><span class="p">)</span>
            <span class="p">)</span>
        <span class="p">)</span>

<span class="n">grid_forecasts</span> <span class="o">=</span> <span class="p">[</span><span class="n">fc_grid_2_day_back</span><span class="p">,</span> <span class="n">fc_grid_1_day_back</span><span class="p">,</span> <span class="n">fc_grid</span> <span class="p">]</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="grid-pp:-1.-Transform-forecasts-from-grid-to-observation-points-(IDW)">
<h3>grid-pp: 1. Transform forecasts from grid to observation points (IDW)<a class="headerlink" href="#grid-pp:-1.-Transform-forecasts-from-grid-to-observation-points-(IDW)" title="Permalink to this headline">¶</a></h3>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[9]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Now we have 3 simulated forecasts at a 1x1 km grid</span>
<span class="c1"># fc_grid, fc_grid_1_day_back, fc_grid_2_day_back</span>
<span class="c1"># we start to do the grid pp algorithm stuff</span>
<span class="c1"># - we know the our forecasts have some degC. bias, and we would hope that</span>
<span class="c1">#   the kalman filter &#39;learns&#39; the offset</span>
<span class="c1"># as a first step we project the grid_forecasts to the observation points</span>
<span class="c1"># making a list of historical forecasts at each observation point.</span>

<span class="n">fc_at_observation_points</span> <span class="o">=</span> <span class="p">[</span><span class="n">idw_temperature</span><span class="p">(</span><span class="n">fc</span><span class="p">,</span> <span class="n">obs_points</span><span class="p">,</span> <span class="n">ta</span><span class="o">.</span><span class="n">fixed_dt</span><span class="p">,</span> <span class="n">idw_params</span><span class="p">)</span>\
                            <span class="k">for</span> <span class="n">fc</span> <span class="ow">in</span> <span class="n">grid_forecasts</span><span class="p">]</span>
<span class="n">historical_forecasts</span> <span class="o">=</span> <span class="p">[]</span>
<span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">obs_points</span><span class="p">)):</span>  <span class="c1"># correlate obs.point and fc using common i</span>
    <span class="n">fc_list</span> <span class="o">=</span> <span class="n">TemperatureSourceVector</span><span class="p">()</span>  <span class="c1"># the kalman bias predictor below accepts TsVector of forecasts</span>
    <span class="k">for</span> <span class="n">fc</span> <span class="ow">in</span> <span class="n">fc_at_observation_points</span><span class="p">:</span>
        <span class="n">fc_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">fc</span><span class="p">[</span><span class="n">i</span><span class="p">])</span> <span class="c1"># pick out the fc_ts only, for the i&#39;th observation point</span>
        <span class="c1">#print(&quot;{} adding fc pt {} t0={}&quot;.format(i,fc[i].mid_point(),utc.to_string(fc[i].ts.time(0))))</span>
    <span class="n">historical_forecasts</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">fc_list</span><span class="p">)</span>
<span class="c1"># historical_forecasts  now cntains 3 forecasts for each observation point</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="grid-pp:-2.-Calculate-the-bias-time-series-using-Kalman-filter-on-the-observation-set">
<h3>grid-pp: 2. Calculate the bias time-series using Kalman filter on the observation set<a class="headerlink" href="#grid-pp:-2.-Calculate-the-bias-time-series-using-Kalman-filter-on-the-observation-set" title="Permalink to this headline">¶</a></h3>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[10]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Create a TemperatureSourceVector to hold the set of bias time-series</span>
<span class="n">bias_set</span> <span class="o">=</span> <span class="n">TemperatureSourceVector</span><span class="p">()</span>

<span class="c1"># Create the Kalman filter having 8 samples spaced every 3 hours to represent a daily periodic pattern</span>

<span class="n">kalman_dt_hours</span> <span class="o">=</span> <span class="mi">3</span>
<span class="n">kalman_dt</span> <span class="o">=</span><span class="n">deltahours</span><span class="p">(</span><span class="n">kalman_dt_hours</span><span class="p">)</span>
<span class="n">kta</span> <span class="o">=</span> <span class="n">TimeAxis</span><span class="p">(</span><span class="n">t0</span><span class="p">,</span> <span class="n">kalman_dt</span><span class="p">,</span> <span class="nb">int</span><span class="p">(</span><span class="mi">24</span><span class="o">//</span><span class="n">kalman_dt_hours</span><span class="p">))</span>

<span class="c1"># Calculate the coefficients of Kalman filter and</span>
<span class="c1"># Create bias time-series based on the daily periodic pattern</span>
<span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">obs_set</span><span class="p">)):</span>
    <span class="n">kf</span> <span class="o">=</span> <span class="n">KalmanFilter</span><span class="p">()</span> <span class="c1"># each observation location do have it&#39;s own kf &amp;predictor</span>
    <span class="n">kbp</span> <span class="o">=</span> <span class="n">KalmanBiasPredictor</span><span class="p">(</span><span class="n">kf</span><span class="p">)</span>
    <span class="c1">#print(&quot;Diffs for obs&quot;, i)</span>
    <span class="c1">#for fc in historical_forecasts[i]:</span>
    <span class="c1">#    print((fc.ts-obs_set[i].ts).values.to_numpy())</span>
    <span class="n">kbp</span><span class="o">.</span><span class="n">update_with_forecast</span><span class="p">(</span><span class="n">historical_forecasts</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">obs_set</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="p">,</span> <span class="n">kta</span><span class="p">)</span>
    <span class="n">pattern</span> <span class="o">=</span> <span class="n">KalmanState</span><span class="o">.</span><span class="n">get_x</span><span class="p">(</span><span class="n">kbp</span><span class="o">.</span><span class="n">state</span><span class="p">)</span>
    <span class="c1">#print(pattern)</span>
    <span class="n">bias_ts</span> <span class="o">=</span> <span class="n">create_periodic_pattern_ts</span><span class="p">(</span><span class="n">pattern</span><span class="p">,</span> <span class="n">kalman_dt</span><span class="p">,</span> <span class="n">ta</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">0</span><span class="p">),</span> <span class="n">ta</span><span class="p">)</span>
    <span class="n">bias_set</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">TemperatureSource</span><span class="p">(</span><span class="n">obs_set</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">mid_point</span><span class="p">(),</span> <span class="n">bias_ts</span><span class="p">))</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="grid-pp:-3.-Spread-the-bias-at-observation-points-out-to-the-grid-using-kriging">
<h3>grid-pp: 3. Spread the bias at observation points out to the grid using kriging<a class="headerlink" href="#grid-pp:-3.-Spread-the-bias-at-observation-points-out-to-the-grid-using-kriging" title="Permalink to this headline">¶</a></h3>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[11]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Generate the bias grid by kriging the bias out on the 1x1km grid</span>
<span class="n">btk_params</span> <span class="o">=</span> <span class="n">BTKParameter</span><span class="p">()</span>
<span class="n">btk_bias_params</span> <span class="o">=</span> <span class="n">BTKParameter</span><span class="p">(</span><span class="n">temperature_gradient</span><span class="o">=-</span><span class="mf">0.6</span><span class="p">,</span> <span class="n">temperature_gradient_sd</span><span class="o">=</span><span class="mf">0.25</span><span class="p">,</span> <span class="n">sill</span><span class="o">=</span><span class="mf">25.0</span><span class="p">,</span> <span class="n">nugget</span><span class="o">=</span><span class="mf">0.5</span><span class="p">,</span> <span class="nb">range</span><span class="o">=</span><span class="mf">5000.0</span><span class="p">,</span> <span class="n">zscale</span><span class="o">=</span><span class="mf">20.0</span><span class="p">)</span>
<span class="n">bias_grid</span> <span class="o">=</span>  <span class="n">bayesian_kriging_temperature</span><span class="p">(</span><span class="n">bias_set</span><span class="p">,</span> <span class="n">grid_1x1</span><span class="p">,</span> <span class="n">ta</span><span class="o">.</span><span class="n">fixed_dt</span><span class="p">,</span> <span class="n">btk_bias_params</span><span class="p">)</span>
<span class="c1"># Correct forecasts by applying bias time-series on the grid</span>
<span class="n">fc_grid_improved</span> <span class="o">=</span> <span class="n">TemperatureSourceVector</span><span class="p">()</span>
<span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">fc_grid</span><span class="p">)):</span>
    <span class="n">fc_grid_improved</span><span class="o">.</span><span class="n">append</span><span class="p">(</span>
        <span class="n">TemperatureSource</span><span class="p">(</span>
            <span class="n">fc_grid</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">mid_point</span><span class="p">(),</span>
            <span class="n">fc_grid</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span> <span class="o">-</span> <span class="n">bias_grid</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span> <span class="c1"># By convention, sub bias time-series(hmm..)</span>
        <span class="p">)</span>
    <span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[12]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Check the first value of the time-series. It should be around 15</span>
<span class="n">tx</span> <span class="o">=</span><span class="n">ta</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Comparison original synthetic grid cell [0]</span><span class="se">\n\t</span><span class="s2"> at the lower left corner,</span><span class="se">\n\t</span><span class="s2"> at t </span><span class="si">{}</span><span class="se">\n\t</span><span class="s2">original grid: </span><span class="si">{}</span><span class="se">\n\t</span><span class="s2">improved grid: </span><span class="si">{}</span><span class="se">\n\t</span><span class="s2"> vs bias grid: </span><span class="si">{}</span><span class="se">\n\t</span><span class="s2"> nearest obs: </span><span class="si">{}</span><span class="s2">&quot;</span>
      <span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">utc</span><span class="o">.</span><span class="n">to_string</span><span class="p">(</span><span class="n">tx</span><span class="p">),</span>
              <span class="n">fc_grid</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="p">(</span><span class="n">tx</span><span class="p">),</span>
              <span class="n">fc_grid_improved</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="p">(</span><span class="n">tx</span><span class="p">),</span>
              <span class="n">bias_grid</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="p">(</span><span class="n">tx</span><span class="p">),</span>
              <span class="n">obs_set</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="p">(</span><span class="n">tx</span><span class="p">)</span>
             <span class="p">)</span>
      <span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Comparison original synthetic grid cell [0]
         at the lower left corner,
         at t 2016-01-01T00:00:00Z
        original grid: 18.985602994492123
        improved grid: 19.740020177551433
         vs bias grid: -0.7544171830593106
         nearest obs: 19.94
</pre></div></div>
</div>
</div>
<div class="section" id="Presentation&amp;Test:-8.-Finally,-Transform-corrected-forecasts-from-grid-to-observation-points-to-see-if-we-did-reach-the-goal-of-adjusting-the-forecast-(IDW)">
<h3>Presentation&amp;Test: 8. Finally, Transform corrected forecasts from grid to observation points to see if we did reach the goal of adjusting the forecast (IDW)<a class="headerlink" href="#Presentation&Test:-8.-Finally,-Transform-corrected-forecasts-from-grid-to-observation-points-to-see-if-we-did-reach-the-goal-of-adjusting-the-forecast-(IDW)" title="Permalink to this headline">¶</a></h3>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[13]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Generate the corrected forecast set by Krieging transform of temperature model</span>
<span class="n">fc_at_observations_improved</span> <span class="o">=</span> <span class="n">idw_temperature</span><span class="p">(</span><span class="n">fc_grid_improved</span><span class="p">,</span> <span class="n">obs_points</span><span class="p">,</span> <span class="n">ta</span><span class="o">.</span><span class="n">fixed_dt</span><span class="p">,</span> <span class="n">idw_params</span><span class="p">)</span>
<span class="n">fc_at_observations_raw</span> <span class="o">=</span><span class="n">idw_temperature</span><span class="p">(</span><span class="n">fc_grid</span><span class="p">,</span> <span class="n">obs_points</span><span class="p">,</span> <span class="n">ta</span><span class="o">.</span><span class="n">fixed_dt</span><span class="p">,</span> <span class="n">idw_params</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="9.-Plot-the-results">
<h3>9. Plot the results<a class="headerlink" href="#9.-Plot-the-results" title="Permalink to this headline">¶</a></h3>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[14]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Make a time-series plot of temperature sets</span>
<span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">bias_set</span><span class="p">)):</span>
    <span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">20</span><span class="p">,</span> <span class="mi">10</span><span class="p">))</span>
    <span class="n">timestamps</span> <span class="o">=</span> <span class="p">[</span><span class="n">datetime</span><span class="o">.</span><span class="n">datetime</span><span class="o">.</span><span class="n">utcfromtimestamp</span><span class="p">(</span><span class="n">p</span><span class="o">.</span><span class="n">start</span><span class="p">)</span> <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">obs_set</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">time_axis</span><span class="p">]</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">timestamps</span><span class="p">,</span> <span class="n">obs_set</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39; Observation&#39;</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">timestamps</span><span class="p">,</span> <span class="n">fc_at_observations_improved</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39; Forecast improved&#39;</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">timestamps</span><span class="p">,</span> <span class="n">fc_at_observations_raw</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">values</span><span class="p">,</span><span class="n">linestyle</span><span class="o">=</span><span class="s1">&#39;--&#39;</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39; Forecast (raw)&#39;</span><span class="p">)</span>
    <span class="c1">#ax.plot(timestamps, bias_set[i].ts.values, label = str(i+1) + &#39; Bias&#39;)</span>
    <span class="n">fig</span><span class="o">.</span><span class="n">autofmt_xdate</span><span class="p">()</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">title</span><span class="o">=</span><span class="s1">&#39;Temperature&#39;</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s1">&#39;Temp ($^\circ$C)&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_grid-pp_gridpp_geopoints_21_0.png" src="../../_images/notebooks_grid-pp_gridpp_geopoints_21_0.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_grid-pp_gridpp_geopoints_21_1.png" src="../../_images/notebooks_grid-pp_gridpp_geopoints_21_1.png" />
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_grid-pp_gridpp_geopoints_21_2.png" src="../../_images/notebooks_grid-pp_gridpp_geopoints_21_2.png" />
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_grid-pp_gridpp_geopoints_21_3.png" src="../../_images/notebooks_grid-pp_gridpp_geopoints_21_3.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[15]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Make a scatter plot of grid temperature forecasts at ts.value(0)</span>
<span class="n">x</span> <span class="o">=</span> <span class="p">[</span><span class="n">fc</span><span class="o">.</span><span class="n">mid_point</span><span class="p">()</span><span class="o">.</span><span class="n">x</span> <span class="k">for</span> <span class="n">fc</span> <span class="ow">in</span> <span class="n">bias_grid</span><span class="p">]</span>
<span class="n">y</span> <span class="o">=</span> <span class="p">[</span><span class="n">fc</span><span class="o">.</span><span class="n">mid_point</span><span class="p">()</span><span class="o">.</span><span class="n">y</span> <span class="k">for</span> <span class="n">fc</span> <span class="ow">in</span> <span class="n">bias_grid</span><span class="p">]</span>
<span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">10</span><span class="p">,</span> <span class="mi">5</span><span class="p">))</span>
<span class="n">temps</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">bias</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">value</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span> <span class="k">for</span> <span class="n">bias</span> <span class="ow">in</span> <span class="n">bias_grid</span><span class="p">])</span>
<span class="n">plot</span> <span class="o">=</span> <span class="n">ax</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">c</span><span class="o">=</span><span class="n">temps</span><span class="p">,</span> <span class="n">marker</span><span class="o">=</span><span class="s1">&#39;o&#39;</span><span class="p">,</span> <span class="n">s</span><span class="o">=</span><span class="mi">500</span><span class="p">,</span> <span class="n">lw</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">colorbar</span><span class="p">(</span><span class="n">plot</span><span class="p">)</span><span class="o">.</span><span class="n">set_label</span><span class="p">(</span><span class="s1">&#39;Temp bias correction ($^\circ$C)&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_grid-pp_gridpp_geopoints_22_0.png" src="../../_images/notebooks_grid-pp_gridpp_geopoints_22_0.png" />
</div>
</div>
</div>
</div>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="kalman_updating.html" class="btn btn-neutral float-right" title="This notebook sets up a Kalman filter and demonstrates how choice of parameters impact the updating" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="../nea-example/advanced_simulation.html" class="btn btn-neutral float-left" title="Simulation with the Shyft API" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>